package BConverter;
/*
 * CDensidad.java
 * @author Valois at buayacorp
 * Este script est bajo licencia de Creative Commons 
 * http://creativecommons.org/licenses/by/2.0/
 */

public class CDensidad{
    private String[][] values;    

    /**
  	*  Creates a new instance of CDensidad 
  	*/
    public CDensidad(){
        /**
      	*  Nmero total de medidas 8
      	*/
        values = new String[9][8];
 
        /**
      	*  Tabla de valores
      	*/
        add(0, "Gram/Centimetros",      "Gram/Metros", "Kilogramos/Metros",  "Miligramos/Metros",         "Onzas/Galon",        "Libras/Pies", "Libras/Pulgadas", "Toneladas/Yardas");
        add(1,                "1",         "0.000001",             "0.001",        "0.000000001", "0.00748915009380161", "0.0160184635217938",  "27.67990624262",   "0.693592385465");
        add(2,          "1000000",                "1",              "1000",              "0.001",            "7489.152",           "16018.46",        "27679900",         "693592.5");
        add(3,             "1000",            "0.001",                 "1",           "0.000001",     "7.4891500938016",   "16.0184635217938",         "27679.9",         "1328.939");
        add(4,       "1000000000",             "1000",           "1000000",                  "1",             "7489152",           "16018460",     "27679900000",        "693592500");
        add(5,         "133.5265",    "0.00013352647",         "0.1335265",    "0.0000001335265",                   "1",           "2.138889",            "3696",       "92.6130018");
        add(6,         "62.42796",    "0.00006242796",        "0.06242796",   "0.00000006242796",           "0.4675325",                  "1",            "1728",        "43.299565");
        add(7,       "0.03612729", "0.00000003612730",     "0.00003612729", "0.0000000000361273",        "0.0002705628",       "0.0005787037",               "1",       "0.02505762");
        add(8,         "1.441769",   "0.000001441769",        "0.00075248", "0.0000000014417688",          "0.01079762",         "0.02309492",        "39.90802",                "1");

    }

    /**
  	*  Retorna un valor de la tabla
  	*/
    public String Value(int i, int j){
       j++;
       if(i<values.length && i>=0 && j<values.length && j>=0)
          return values[j][i];
       else
          return "0";
    }
    
    /**
  	*  Retorna el Menu
  	*/
    public String[] Menu(){
      return values[0];
    }
    
    /**
  	*  Retorna el nombre de la Medida
  	*/
    public String Measure(int i){
        return values[0][i];
    }
    
    /**
  	*  Agrega un valor a la tabla
  	*/
    private void add(int i,
            String s1,
            String s2, 
            String s3,
            String s4,
            String s5, 
            String s6, 
            String s7, 
            String s8){
       String[] newString={s1, s2, s3, s4, s5, s6, s7, s8};
       values[i]=newString;       
    }
}
