package BConverter;
/*
 * Converter.java
 * Created on 23 de julio de 2005, 1:34 PM
 */
/**
 * @author Valois at buayacorp
 */
public class Converter {
    // Volumen
    private String[] mainMenu = {"Angulo", "Area", "Datos", "Densidad", "Energa", "Fuerza", "Longitud", "Poder", "Presin", "Temperatura", "Tiempo", "Torque", "Velocidad", "Volumen", "Peso"};
    private String[] subMenu;
    private int menuIndex;
    private String number;
    private String scalar;
    private String additive="0"; // Solo para Temperatura
    

    // Menu Principal
    public Converter(){}

    // Sub Menus
    public Converter(int i){
       menuIndex = i;
       switch(i){
           case 0: subMenu = (new CAngulo()).Menu();
                   break;
           case 1: subMenu = (new CArea()).Menu();
                   break;
           case 2: subMenu = (new CData()).Menu();
                   break;
           case 3: subMenu = (new CDensidad()).Menu();
                   break;
           case 4: subMenu = (new CEnergia()).Menu();
                   break;
           case 5: subMenu = (new CFuerza()).Menu();
                   break;
           case 6: subMenu = (new CLongitud()).Menu();
                   break;
           case 7: subMenu = (new CPoder()).Menu();
                   break;
           case 8: subMenu = (new CPresion()).Menu();
                   break;
           case 9: subMenu = (new CTemperatura()).Menu();
                   break;
           case 10: subMenu = (new CTiempo()).Menu();
                   break;
           case 11: subMenu = (new CTorque()).Menu();
                   break;
           case 12: subMenu = (new CVelocidad()).Menu();
                   break;
           case 13: subMenu = (new CVolumen()).Menu();
                   break;
           case 14: subMenu = (new CPeso()).Menu();
                   break;
       }
    }    

    public void setNumber(String pNumber){
       number = pNumber;
    }
   
    public void setFromTo(int from, int to){
      if(from!=to)
       switch(menuIndex){
           case 0: scalar = (new CAngulo()).Value(from, to);
                   break;
           case 1: scalar = (new CArea()).Value(from, to);
                   break;
           case 2: scalar = (new CData()).Value(from, to);
                   break;
           case 3: scalar = (new CDensidad()).Value(from, to);
                   break;
           case 4: scalar = (new CEnergia()).Value(from, to);
                   break;
           case 5: scalar = (new CFuerza()).Value(from, to);
                   break;
           case 6: scalar = (new CLongitud()).Value(from, to);
                   break;
           case 7: scalar = (new CPoder()).Value(from, to);
                   break;
           case 8: scalar = (new CPresion()).Value(from, to);
                   break;
           case 9: CTemperatura t = new CTemperatura();
                   scalar = t.Value(from, to);
                   additive = t.Additive(from, to);
                   break;
           case 10: scalar = (new CTiempo()).Value(from, to);
                   break;
           case 11: scalar = (new CTorque()).Value(from, to);
                   break;
           case 12: scalar = (new CVelocidad()).Value(from, to);
                   break;
           case 13: scalar = (new CVolumen()).Value(from, to);
                   break;
           case 14: scalar = (new CPeso()).Value(from, to);
                   break;
       }
      else
        scalar = "1";
    }
    
    public String[] getMainMenu(){
       return mainMenu;
    }
    
    public String[] getSubMenu(){
       return subMenu;
    }
    
    public String getResult(){
        Engine e = new Engine(scalar, number);
        if(menuIndex==9) //Temperatura
            return e.add(e.Doit(), additive);
        else
            return e.Doit();
    }
    
    public String getName(int subMenuIndex){
       return subMenu[subMenuIndex];
    }
}