package BConverter;
/*
 * Engine.java
 * Procesa los dos nmeros Float considerando que son Strings
 * @author Valois at buayacorp
 * Este script est bajo licencia de Creative Commons 
 * http://creativecommons.org/licenses/by/2.0/
 */

import java.io.*;
public class Engine {
    /*
     * Guarda el escalar a multiplicar con el nmero e.g. 
     * Para convertir litros a barriles(aceite)
     *           litros * 158.9873(escalar) = barriles(aceite)
     * Escalar representado:
     *           158.9873 = 1589873 * 10^-4
     *           scalar   = 1589873, decimals = 4
     */
    private long scalar;
    private int decimals;

    /**
  	*  Guarda un nmero pasado desde Converter
  	*/
    private String number;    
    
    /**
  	*  Creates a new instance of Engine
  	*/
    public Engine(String pFactor, String pNumber2) {
      this.decimals = NumberOfDecimals(pFactor);      
      this.scalar   = StandardizeNumber(pFactor, this.decimals);      
      this.number=pNumber2;
    }

    /**
  	*  Setea decimals y number
  	*/
    public void SetNumbers(String pFactor, String pNumber2){
      this.decimals = NumberOfDecimals(pFactor);      
      this.scalar   = StandardizeNumber(pFactor, this.decimals);      
      this.number=pNumber2;   
    }

    /**
  	*  Opera el scalar y el nmero 
  	*/
    public String Doit(){
      String result;
      result = TreatNumber();
      result = CropZeros(result);
      int decimals2;
      decimals2 = NumberOfDecimals(result);
      long bigNumber;          
      bigNumber = StandardizeNumber(result, decimals2);
      bigNumber = bigNumber * this.scalar;
      result = Number2Float(bigNumber, decimals + decimals2);
      result = CropZeros(result);
      result = TreatOutput(result);
      return result;
    }
    
    /**
  	*  Suma dos Floats como Strings
  	*/
    public String add(String n1, String n2){
      int decimals=0;
      if(NumberOfDecimals(n1)>NumberOfDecimals(n2))
        decimals = NumberOfDecimals(n1);
      else
        decimals = NumberOfDecimals(n2);  
      if(n1.indexOf(".")==-1)
          n1=n1+".";
      if(n2.indexOf(".")==-1)
          n2=n2+".";
      long result;
      result = StandardizeNumber(n1, decimals) + StandardizeNumber(n2, decimals); 
      return TreatOutput(Number2Float(result, decimals));
    }
    

    /**
  	*  Reemplaza , por .
  	*/
    private String TreatNumber(){
      String result;
      result=this.number;
      if(result.indexOf(",")!=-1)
        result=result.replace(',', '.');      
      return result;  
    }
    
    /**
  	*  Reemplaza . por , si es necesario
  	*/
    private String TreatOutput(String pNumber){
      String result;
      result=pNumber;
      if(this.number.indexOf(",")!=-1)
         result=result.replace('.', ',');
      
      int resultLen=result.length();
      if(resultLen>1)
         if(result.substring(resultLen-1, resultLen).compareTo(".")==0)
             result = result.substring(0, resultLen-1);
      return result;
    }
    
    /**
  	*  Elimina los ceros de los nmeros: 9.100 3.40 20.20
  	*/
    private String CropZeros(String number){
      boolean ok=true;
      int numberDotIndex = number.indexOf(".");
      int numberLen = number.length();
      if(numberDotIndex!=-1){
        if(numberLen>1){
            while(ok){
                if((number.substring(numberLen-1, numberLen)).compareTo("0")==0){
                  number = number.substring(0, numberLen-1);
                  numberLen = number.length();                  
                }
                else
                  ok=false;
            }
        }
        if(numberLen==1)
           number="0";
      }
      return number;
    }

    /**
  	*  Cuenta el nmero de Decimales de un nmero e.g. 4.003  numberOfDecimals = 3
  	*/
    private int NumberOfDecimals(String number){
       String result=number;       
       if(result.indexOf(".")!=-1)
         return (result.substring(result.indexOf(".")+1, result.length())).length();
       else
         return 0;
    }

    /**
  	*  De 45.44 a 4544
  	*/
    private long StandardizeNumber(String number, int decimals){
       String result;
       result = number;
       
       int indexDot=result.indexOf("."); 
       if(indexDot!=-1){           
           result = result.substring(0, indexDot)+result.substring(indexDot+1, result.length());
           int i=1;
           while(i<=decimals){
              if(indexDot>result.length()-1)
                result = result+"0";          
              indexDot++;
              i++;
           }
       }       
       return java.lang.Long.parseLong(result);
    }

    /**
  	*  De 4544 a 45.44
  	*/
    private String Number2Float(long number, int decimals){
       String result=number + "";
       if(result.length()<=decimals)
        while(result.length()<=decimals)
          result = "0" + result;
       result=result.substring(0, result.length() - decimals) + "." + result.substring(result.length() - decimals, result.length());
       return result;
    }
}
