/*
 * BConverter 1.0 beta
 * @author Valois at buayacorp
 * Este script est bajo licencia de Creative Commons 
 * http://creativecommons.org/licenses/by/2.0/
 */

/**
*  javax.microedition.midlet.*; Importa las clases para el soporte de:
*     1. Clase MIDlet
*     2. CommandAction interface
*     3. User interface (UI) classes
*  Mtodos imprescindibles para un MIDLET
*     1. startApp()
*     2. pauseApp()
*     3. destroyApp(boolean unconditional)
*     4. commandAction(Command command, Displayable screen)
*/
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import java.io.IOException;
import BConverter.*;

public class Main extends MIDlet implements CommandListener
{
    /**
  	*  Manejo de pantalla
  	*/
    private Display display;  // Establece que debe mostrarse en un instante
    private ImgCanvas screen; // Muestra la Imagen de la clase ImgCanvas que esta abajo 
    
    /**
  	*  mainMenuCommands: Guarda los commandos del menu principal de la App
  	*  mainScreen: Guarda el menu principal(mainMenuCommands) de la App  	
  	*/    
    private Command mainMenuCommands[];
    private ImgCanvas mainScreen;

    /**
    *  Comandos de los submenus
  	*/    
    private Command cmds[]; // 
    
    /**
  	*  Comandos de uso general
  	*/
    private Command exitCommand;
    private Command convertToCommand;
    private Command okCommand;
    private Command backCommand;

    /**
  	*  Clase para el manejo de unidades y de clculo
  	*/
    private Converter converter;

    /**
  	*  Variables de estado
  	*/
    private int stateMainMenu=-1;
    private int stateSubMenu=-1;
    private int stateSubMenu2=-1;
    private boolean isWritten;

    /**
  	*  number: Guarda al nmero ingresado
  	*  input:  Muestra el TextEdit o TextBox
  	*/
    private String number="";
    private TextBox input;
    
    /**
  	*  Mensajes usados a lo largo de la App
  	*/
    private String[] guiMsg = new String[12];

    /**
  	*  Creates a new instance of Main
  	*/
    public Main()
    {      
       guiMsg[0] = "Anterior";
       guiMsg[1] = "# Invalido! ";
       guiMsg[2] = "Otra unidad";
       guiMsg[3] = "Ingrese (";guiMsg[4] = ")";
       guiMsg[5] = "Convertir a";
       guiMsg[6] = "Resultado (";guiMsg[7] = ")";
       guiMsg[8] = "OK";
       guiMsg[9] = "Salir";
       guiMsg[10] = "Otro #";
       guiMsg[11] = "Inicio";
       mainScreen = LoadMainMenu(); // Carga los mainMenuCommands
    }

    /**
  	*  Primer mtodo que se ejecuta en el MIDLET
  	*/
    public void startApp()
    {
        display = Display.getDisplay(this);
        showMainMenu();
    }

    /**
     * PauseApp usado para suspender actividades background
     */
    public void pauseApp(){}
    
    /**
     * DestroyApp finaliza la App
     */
    public void destroyApp(boolean unconditional){}
    
    /**
     * Gestiona los botones presionados
     */
    public void commandAction(Command command, Displayable screen)
    {
      if(command == backCommand)
      {
         /**
       	 *  Maneja los retornos de la App
       	 */
         if(stateMainMenu!=-1){
            if(stateSubMenu!=-1){
                if(isWritten){
                    if(stateSubMenu2!=-1){
                       showSubMenu();
                       stateSubMenu2=-1;
                    }
                    else{
                       isWritten=false;
                       showEditBox();
                       backCommand = new Command(guiMsg[0], Command.BACK, 1);
                       input.addCommand(backCommand);
                       input.setCommandListener( (CommandListener) this);
                       display.setCurrent(input);
                    }
                }
                else{
                   showSubMenu();
                   stateSubMenu=-1;
                }
            }
            else{
              showMainMenu();
              stateMainMenu=-1;
            }
         }         
      }
      else if(command == exitCommand)
      {   
         /**
       	 *  Fin de la Aplicacin
       	 */
          display.setCurrent(null);
          destroyApp(false);
          notifyDestroyed();
      }
      else if(command == convertToCommand)
      {
         /**
       	 *  Listar el 2do submenu
       	 */
          if(stateMainMenu!=-1){
             number = input.getString();
             if(isNumeric()){
               isWritten = true;
               showSubMenu();
             }
             else{
               isWritten=false;
               showEditBox();
               input.setTitle(guiMsg[1] + input.getTitle());
               backCommand = new Command(guiMsg[0], Command.BACK, 1);                       
               input.addCommand(backCommand);
               input.setCommandListener( (CommandListener) this);
               display.setCurrent(input);
             }
          }
          else
             showMainMenu();
      }
      else if(command == okCommand)
      {
         /**
       	 *  Fin de la Conversion, retorna al 2do Menu 
       	 *  dentro de la misma Unidad que se escogi anteriormente
       	 */
          stateSubMenu = -1;
          isWritten = false;
          showSubMenu();
          number="";
      }

     /**
   	 *  Gestion de botones del Menu Principal
   	 */
      int i=0;     
      if(stateMainMenu==-1){

      for(i=0;i<mainMenuCommands.length;i++)
          if(command == mainMenuCommands[i])
          {
            stateMainMenu=i;
            showSubMenu();
            i=mainMenuCommands.length;            
          }
      }

     /**
   	 *  Gestion de botones de los Sub Menus
   	 */
      if(stateMainMenu!=-1)
      for(i=0;i<cmds.length;i++)
          if(command == cmds[i])
          {
             if(stateSubMenu==-1){

               /**
             	 *  Primera vez en el submenu, Escriba el # por favor
             	 */

                stateSubMenu=i;
                showEditBox();
                backCommand = new Command(guiMsg[0], Command.BACK, 1);
             }
             else{

               /**
             	 *  Calculo del nmero
             	 */
             	 
                stateSubMenu2 = i;
                converter = new Converter(stateMainMenu);
                converter.setNumber(number);
                converter.setFromTo(stateSubMenu, i);
                showResult();
                backCommand = new Command(guiMsg[2], Command.BACK, 1);
             }

             /**
           	 *  Agrega el commando backCommand al Textbox o Textedit
           	 */

             input.addCommand(backCommand);
             input.setCommandListener( (CommandListener) this);
             display.setCurrent(input);
             i=cmds.length;
          }
    }
    
    /**
  	*  Obviamente eso
  	*/
    private void showEditBox(){
        input = new TextBox(guiMsg[3] + converter.getName(stateSubMenu) + guiMsg[4], number, 64, 0);
        convertToCommand = new Command(guiMsg[5], Command.OK, 1);
        input.addCommand(convertToCommand);
    }

    /**
  	*  Obviamente eso
  	*/
    private void showResult(){
        input = new TextBox(guiMsg[6] + converter.getName(stateSubMenu2) + guiMsg[7], converter.getResult(), 64, 0);
        okCommand = new Command(guiMsg[8], Command.OK, 1);
        input.addCommand(okCommand);        
    }

    /**
  	*  Obviamente eso
  	*/
    private void showMainMenu(){
       screen = new ImgCanvas();
       screen = mainScreen;       
       screen.setCommandListener(this); 
       display.setCurrent(screen);
    }
    
    /**
  	*  Obviamente eso
  	*/
    private void showSubMenu(){
        screen = new ImgCanvas();
        screen = LoadSubMenu();
        screen.addImg(stateMainMenu);
        screen.setCommandListener(this);
        if(isWritten)
            screen.onTo();
        else
            screen.onFrom();
        display.setCurrent(screen);
    }
    

    /**
  	*  Carga los mainMenuCommands
  	*/
    private ImgCanvas LoadMainMenu(){
       ImgCanvas screen = new ImgCanvas();
       Converter c = new Converter();
       String[] mainMenu = c.getMainMenu();
       mainMenuCommands = new Command[mainMenu.length];
       int i;
       for(i=0;i<mainMenu.length;i++){          
          mainMenuCommands[i] = new Command(mainMenu[i], Command.SCREEN, 2);
          screen.addCommand(mainMenuCommands[i]);          
       }
       exitCommand = new Command(guiMsg[9], Command.EXIT, 1);
       screen.addCommand(exitCommand);
       return screen;
    }

    /**
  	*  Carga los subMenus en cmds
  	*/
    private ImgCanvas LoadSubMenu(){
       ImgCanvas screen = new ImgCanvas();
       converter = new Converter(stateMainMenu);
       String[] menu = converter.getSubMenu();
       cmds = new Command[menu.length];
       int i;
       for(i=0;i<menu.length;i++){
           cmds[i] = new Command(menu[i], Command.SCREEN, 2);
           screen.addCommand(cmds[i]);
       }
       if(isWritten)
         backCommand = new Command(guiMsg[10], Command.BACK, 1);
       else
         backCommand = new Command(guiMsg[11], Command.BACK, 1);
       screen.addCommand(backCommand);
       return screen;
    }

    /**
  	*  Mtodo que asegura el ingreso de nmeros, cualquier sugerencia Por favor haganmelo saber
  	*/
    private boolean isNumeric(){
      int i;
      boolean ok = true;
      boolean foundDot = false;
      boolean foundComma = false;
      if(number.length()>0)
      {
       number = number.trim();
       for(i=0;i<number.length();i++)
        if(!java.lang.Character.isDigit(number.charAt(i)))
          if(number.charAt(i)!=',')
              if(number.charAt(i)!='.'){
                ok = false; 
                i = number.length(); 
              }
              else
                if(foundDot || foundComma){
                  ok = false;
                  i = number.length();                
                }
                else
                    foundDot = true;
          else
              if(foundComma || foundDot){
                ok = false;
                i = number.length();
              }                  
              else
                foundComma = true;
      }
      else
        ok = false;
      return ok;
    }
}

/**
*  Maneja las imagenes de las pantallas
*/
class ImgCanvas extends Canvas{

  /**
	*  Guarda las Imagenes de Inicio y menus
	*/
  private Image imgStartUp;
  private Image imgMenu;
  
  /**
	*  Variables bandera
	*/  
  private boolean subMenuOn = false;
  private boolean fromOn = false;
  private boolean toOn = false;

  /**
	*  Imagenes adicionales "CONVERTIR A" y "CONVERTIR DE"
	*/  
  private Image imgFrom;
  private Image imgTo;

  /**
	*  Creates a new instance of ImgCanvas
	*/
  public ImgCanvas(){
    try {
        imgStartUp = Image.createImage("/startup.png");
        imgFrom = Image.createImage("/de.png");
        imgTo = Image.createImage("/a.png");
    }catch (IOException e) {
        System.err.println("No se pudo cargar las imagenes : " + e.toString());
    }    
  }

  /**
	*  Gestiona las banderas "CONVERTIR A" y "CONVERTIR DE"
	*/
  public void onFrom(){
    fromOn = true;
    toOn = false;
  }
  public void onTo(){
    toOn = true;
    fromOn = false;
  }
  
  /**
	*  Mtodo accedido desde Main para agregar Imgs de los menus
	*/  
  public void addImg(int i){
    try {
        imgMenu= Image.createImage("/screen"+i+".png");
        subMenuOn = true;
    }catch (IOException e) {
        System.err.println("No se pudo cargar la imagen : " + e.toString());
    }
  }

  /**
	*  Mtodo que refresca la pantalla
	*/  
  public void paint(Graphics g){
    draw(g);
  }
  
  /**
	*  Mtodo que dibuja las imagenes
	*/  
  public void draw(Graphics g) {
    g.drawImage(imgStartUp, 65,  48, Graphics.HCENTER|Graphics.VCENTER);
    if(subMenuOn)
       g.drawImage(imgMenu, 80,  60, Graphics.HCENTER|Graphics.VCENTER);
    if(fromOn && !toOn)
       g.drawImage(imgFrom, 65,  5, Graphics.HCENTER|Graphics.VCENTER);
    if(toOn && !fromOn)
       g.drawImage(imgTo, 65,  5, Graphics.HCENTER|Graphics.VCENTER);
  }
}
